﻿Option Strict On
Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Windows.Data
Imports System.Windows.Input
Imports CollectionViewSourceTest.ViewModel.Instrastructure

Public Class MainViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase

    Private _AnzuzeigendeDaten As ICollectionView
    Private DieseKlasse As MainModul.MeineDaten = New MainModul.MeineDaten


    Public Sub New()


        'Musikdaten = New ObservableCollection(Of Model.Daten)
        MainModul.MeineDaten.MusikDaten.Add(New Model.Daten("Michael Jackson", "HIStory", "Billie Jean"))
        MainModul.MeineDaten.MusikDaten.Add(New Model.Daten("Green Day", "21st Century Breakdown", "21 Guns"))
        MainModul.MeineDaten.MusikDaten.Add(New Model.Daten("Cypress Hill", "IV", "Tequila Sunrise"))
        MainModul.MeineDaten.MusikDaten.Add(New Model.Daten("Nelly", "Sweat Suit", "My Place"))

        _AnzuzeigendeDaten = CollectionViewSource.GetDefaultView(MainModul.MeineDaten.MusikDaten)
        _AnzuzeigendeDaten.Filter = AddressOf Filter

    End Sub

    Private Function Filter(obj As Object) As Boolean
        Dim Objekt As Model.Daten = DirectCast(obj, Model.Daten)
        If Objekt.Interpret = "Michael Jackson" Then
            Return False
        Else
            Return True
        End If
    End Function

    Public ReadOnly Property AnzuzeigendeDaten As ICollectionView
        Get
            Return _AnzuzeigendeDaten
        End Get
    End Property
    'Private _MusikDaten As ObservableCollection(Of Model.Daten)
    'Public Property MusikDaten As ObservableCollection(Of Model.Daten)
    '    Get
    '        Return _MusikDaten
    '    End Get
    '    Set(value As ObservableCollection(Of Model.Daten))
    '        _MusikDaten = value
    '        RaisePropertyChanged()
    '    End Set
    'End Property

    Private _DatenSatzZufuegen As ICommand
    Public ReadOnly Property DatenSatzZufuegen() As ICommand
        Get
            If _DatenSatzZufuegen Is Nothing Then _DatenSatzZufuegen = New RelayCommand(AddressOf DatenSatzZufuegen_Execute, Function(o) True)
            Return _DatenSatzZufuegen
        End Get
    End Property
    Private Sub DatenSatzZufuegen_Execute(obj As Object)
        MainModul.MeineDaten.MusikDaten.Add(New Model.Daten("Michael Jackson", "Sweat Suit", "My Place"))
    End Sub

End Class
